/********************************************************************************************************
 * @file     app.c
 *
 * @brief    This is the EMI file for TLSR8278
 *
 * @author	 Driver Group
 * @date     May 8, 2018
 *
 * @par      Copyright (c) 2018, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *           The information contained herein is confidential property of Telink
 *           Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *           of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *           Co., Ltd. and the licensee or the terms described here-in. This heading
 *           MUST NOT be removed from this file.
 *
 *           Licensees are granted free, non-transferable use of the information in this
 *           file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 * @par      History:
 * 			 1.initial release(DEC. 26 2018)
 *
 * @version  A001
 *
 *******************************************************************************************************/

#include "app_config.h"

#if(TEST_DEMO==EMI_DEMO)
//#define ATE_SW_TEST		//for ate test when it use single wire to send cmd;then close this define for normal EMI

#define   GPIO_SYS 0xffffffff
const GPIO_PinTypeDef gpio_map[48] = {
	GPIO_PD7,//0
	GPIO_PA0,//1
	GPIO_PA1,//2
	GPIO_PA2,//3
	GPIO_PA3,//4
	GPIO_PA4,//5
	GPIO_PA5,//6
	GPIO_PA6,//7
	GPIO_PA7,//8
	GPIO_PB0,//9
	GPIO_PB1,//10
//	GPIO_SYS,//11
//	GPIO_SYS,//12
//	GPIO_SYS,//13
//	GPIO_SYS,//14
//	GPIO_SYS,//15
//	GPIO_SYS,//16
//	GPIO_SYS,//17
//	GPIO_SYS,//18
	GPIO_PB2,//19
	GPIO_PB3,//20
	GPIO_PB4,//21
	GPIO_PB5,//22
	GPIO_PB6,//23
	GPIO_PB7,//24
//	GPIO_SYS,//25
//	GPIO_SYS,//26
	GPIO_PC0,//27
	GPIO_PC1,//28
	GPIO_PC2,//29
	GPIO_PC3,//30
	GPIO_PC4,//31
	GPIO_PC5,//32
	GPIO_PC6,//33
	GPIO_PC7,//34
//	GPIO_SYS,//35
//	GPIO_SYS,//36
//	GPIO_SYS,//37
//	GPIO_SYS,//38
//	GPIO_SYS,//39
//	GPIO_SYS,//40
	GPIO_PD0,//41
	GPIO_PD1,//42
	GPIO_PD2,//43
	GPIO_PD3,//44
	GPIO_PD4,//45
	GPIO_PD5,//46
	GPIO_PD6//47
};
#ifdef ATE_SW_TEST
const unsigned char rf_power_Level_list_ate[63]={
 /*VBAT*/
 /*RF_POWER_P10p46dBm*/63,
 /*RF_POWER_P10p29dBm*/62,
 /*RF_POWER_P10p01dBm*/61,
 /*RF_POWER_P9p81dBm*/60,
 /*RF_POWER_P9p48dBm*/59,
 /*RF_POWER_P9p24dBm*/58,
 /*RF_POWER_P8p97dBm*/57,
 /*RF_POWER_P8p73dBm*/56,
 /*RF_POWER_P8p44dBm*/55,
 /*RF_POWER_P8p13dBm*/54,
 /*RF_POWER_P7p79dBm*/53,
 /*RF_POWER_P7p41dBm*/52,
 /*RF_POWER_P7p02dBm*/51,
 /*RF_POWER_P6p60dBm*/50,
 /*RF_POWER_P6p14dBm*/49,
 /*RF_POWER_P5p65dBm*/48,
 /*RF_POWER_P5p13dBm*/47,
 /*RF_POWER_P4p57dBm*/46,
 /*RF_POWER_P3p94dBm*/45,
 /*RF_POWER_P3p23dBm=20*/44,

 /*RF_POWER_P3p01dBm*/43,
 /*RF_POWER_P2p81dBm*/42,
 /*RF_POWER_P2p61dBm*/41,
 /*RF_POWER_P2p39dBm*/40,
 /*RF_POWER_P1p99dBm*/39,
 /*RF_POWER_P1p73dBm*/38,
 /*RF_POWER_P1p45dBm*/37,
 /*RF_POWER_P1p17dBm*/36,
 /*RF_POWER_P0p90dBm*/35,
 /*RF_POWER_P0p58dBm*/34,
 /*RF_POWER_P0p04dBm*/33,
 /*RF_POWER_N0p14dBm*/32,
 /*RF_POWER_N0p97dBm*/31,
 /*RF_POWER_N1p42dBm*/30,
 /*RF_POWER_N1p89dBm*/29,
 /*RF_POWER_N2p48dBm*/28,
 /*RF_POWER_N3p03dBm*/27,
 /*RF_POWER_N3p61dBm*/26,
 /*RF_POWER_N4p26dBm*/25,
 /*RF_POWER_N5p03dBm*/24,
 /*RF_POWER_N5p81dBm*/23,
 /*RF_POWER_N6p67dBm*/22,
 /*RF_POWER_N7p65dBm*/21,
 /*RF_POWER_N8p65dBm*/20,
 /*RF_POWER_N9p89dBm*/19,
 /*RF_POWER_N11p4dBm*/18,
 /*RF_POWER_N13p29dBm*/17,
 /*RF_POWER_N15p88dBm*/16,
 /*RF_POWER_N19p27dBm*/15,
 /*RF_POWER_N25p18dBm*/14,
 13,
 12,
 11,
 10,
 9,
 8,
 7,
 6,
 5,
 4,
 3,
 2,
 1


};
#endif

#define MAX_RF_CHANNEL  40
const unsigned char rf_chn_hipping[MAX_RF_CHANNEL] = {
	48,  4, 66, 62, 44,
	12, 38, 16 ,26, 20,
	22, 68, 18, 28,	42,
	32, 34, 36, 14,	40,
	30, 54, 46, 2,	50,
	52, 80, 56, 78,	74,
	8,  64, 6,  24,	70,
	72, 60, 76, 58, 10,
};



unsigned char  mode=1;//1
unsigned char  power_level = 0;
unsigned char  chn = 2;//2
unsigned char  cmd_now=1;//1
unsigned char  run=1;
unsigned char  tx_cnt=0;
unsigned char  hop=0;






struct  test_list_s {
	unsigned char  cmd_id;
	void	 (*func)(RF_ModeTypeDef, unsigned char , signed char);
};

void emicarrieronly(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emi_con_prbs9(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emirx(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emitxprbs9(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emitx55(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emitx0f(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emi_con_tx55(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);
void emi_con_tx0f(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn);

void emi_deepio_noren(RF_ModeTypeDef rf_mode,unsigned char pin,signed char rf_chn);
void emi_deepio_ren(RF_ModeTypeDef rf_mode,unsigned char pin,signed char rf_chn);
void emi_deeptimer_noren(RF_ModeTypeDef rf_mode,unsigned char Sec,signed char rf_chn);
void emi_deeptimer_ren(RF_ModeTypeDef rf_mode,unsigned char Sec,signed char rf_chn);
void emi_suspendio_noren(RF_ModeTypeDef rf_mode,unsigned char pin,signed char rf_chn);
void emi_suspendtimer_noren(RF_ModeTypeDef rf_mode,unsigned char Sec,signed char rf_chn);

struct  test_list_s  ate_list[] = {
		{0x01,emicarrieronly},
		{0x02,emi_con_prbs9},
		{0x03,emirx},
		{0x04,emitxprbs9},
		{0x05,emitx55},
		{0x06,emitx0f},
#ifdef ATE_SW_TEST
		{0x07,emi_con_tx55},
		{0x08,emi_con_tx0f},
#else
		{0x07,emi_deepio_noren},//deep with io wakeup without retension
		{0x08,emi_deeptimer_noren},//deep with timer without retension
#endif
		{0x09,emi_suspendio_noren},//suspend with io wakeup without retension
		{0x0a,emi_suspendtimer_noren},//suspend with timer without retension
		{0x0b,emi_deepio_ren},//deep with io wakeup with retension
		{0x0c,emi_deeptimer_ren},//deep with timer with retension
};



void emi_init(void)
{
	unsigned char chnidx=0;
	write_reg32(0x408,0x29417671 );//access code  0xf8118ac9
	write_reg8(0x13c,0x10); // print buffer size set

	write_reg8(0x40005,tx_cnt);//tx_cnt
	write_reg8(0x40006,run);//run
	write_reg8(0x40007,cmd_now);//cmd
	write_reg8(0x40008,power_level);//power
	write_reg8(0x40009,chn);//chn
	write_reg8(0x4000a,mode);//mode
	write_reg8(0x4000b,hop);//hop
	write_reg8(0x40004,0);
	write_reg32(0x4000c,0);
	gpio_shutdown(GPIO_ALL);//for pm
	analog_write(0x33,0xff);

	flash_read_page(0x77000,1,&chnidx);
	if(chnidx!=0xff)
	{
		chnidx&=0x3f;
		analog_write(0x8a,(analog_read(0x8a)&0xc0)|chnidx);//close internal cap
	}
}



void emi_serviceloop(void)
{
	unsigned char i=0;
	while(1)
	{
	   run = read_reg8(0x40006);  // get the run state!
	   if(run!=0)
	   {
		   power_level = read_reg8(0x40008);
		   chn = read_reg8(0x40009);
		   mode=read_reg8(0x4000a);
		   cmd_now = read_reg8(0x40007);  // get the command!
		   tx_cnt = read_reg8(0x40005);
			for (i=0; i<sizeof (ate_list)/sizeof (struct test_list_s); i++)
			{
				if(cmd_now == ate_list[i].cmd_id)
				{
					if(mode==0)//ble 2M mode
					{
						ate_list[i].func(RF_MODE_BLE_2M,power_level,chn);
					}
					else if(mode==1)//ble 1M mode
					{
						ate_list[i].func(RF_MODE_BLE_1M_NO_PN,power_level,chn);
					}
					else if(mode==2)//zigbee mode
					{
						ate_list[i].func(RF_MODE_ZIGBEE_250K,power_level,chn);
					}
					else if(mode==3)//BLE125K mode
					{
						ate_list[i].func(RF_MODE_LR_S8_125K,power_level,chn);
					}
					else if(mode==4)//BLE500K mode
					{
						ate_list[i].func(RF_MODE_LR_S2_500K,power_level,chn);
					}
					break;
				}
			}
			run = 0;
			write_reg8(0x40006, run);
	   }
	}

}



void emicarrieronly(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{

#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
	rf_emi_single_tone(power,rf_chn);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode ));
	rf_emi_stop();
}

void emi_con_prbs9(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
	unsigned int t0 = reg_system_tick,chnidx=1;
#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
	hop = read_reg8(0x4000b);
	rf_emi_tx_continue_setup(rf_mode,power,rf_chn,0);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode ))
	{
		rf_continue_mode_run();
		if(hop)
		{
			while(!clock_time_exceed(t0,1000000))//run 1ms
			rf_continue_mode_run();

			while(!clock_time_exceed(t0,2000000));//stop 10ms

			t0 = reg_system_tick;
#if 1
			rf_emi_tx_continue_setup(rf_mode,power,rf_chn_hipping[chnidx-1],0);
#else
			rf_emi_tx_continue_setup(rf_mode,pwr,rf_chn_hipping[chnidx-1],0);
#endif
			(chnidx>=MAX_RF_CHANNEL)?(chnidx=1):(chnidx++);
		}
//		else
//		{
//			rf_continue_mode_run();
//		}
	}
	rf_emi_stop();

	write_reg16(0x60, 0x480);
	write_reg8(0xc24, 0x0);
	write_reg8(0xc0e, 0x60);
	write_reg16(0x60, 0x0);

}

void emirx(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
	rf_emi_rx(rf_mode,rf_chn);
	write_reg8(0x40004,0);
	write_reg32(0x4000c,0);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode ))
	{
		rf_emi_rx_loop();
		if(rf_emi_get_rxpkt_cnt()!=read_reg32(0x4000c))
		{
		write_reg8(0x40004,rf_emi_get_rssi_avg());
		write_reg32(0x4000c,rf_emi_get_rxpkt_cnt());
		}
	}
	rf_emi_stop();
}

void emitxprbs9(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
	unsigned int tx_num=0;
#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
	rf_emi_tx_burst_setup(rf_mode,power,rf_chn,0);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode  && ((read_reg8(0x40005)) == tx_cnt ) ))
	{
		rf_emi_tx_burst_loop(rf_mode,0);
		if(tx_cnt)
		{
			tx_num++;
			if(tx_num>=1000)
				break;
		}
	}
	rf_emi_stop();
}


void emitx55(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
	unsigned int tx_num=0;
#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
//	rf_emi_tx_burst_setup_ramp(rf_mode,pwr,rf_chn,2);
	rf_emi_tx_burst_setup(rf_mode,power,rf_chn,2);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode && ((read_reg8(0x40005)) == tx_cnt ) ))
	{
		rf_emi_tx_burst_loop(rf_mode,2);
//		rf_emi_tx_burst_loop_ramp(rf_mode,2);
		if(tx_cnt)
		{
			tx_num++;
			if(tx_num>=1000)
				break;
		}
	}
	rf_emi_stop();
}

void emitx0f(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
	unsigned int tx_num=0;
#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
	rf_emi_tx_burst_setup(rf_mode,power,rf_chn,1);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode && ((read_reg8(0x40005)) == tx_cnt ) ))
	{
		rf_emi_tx_burst_loop(rf_mode,1);
		if(tx_cnt)
		{
			tx_num++;
			if(tx_num>=1000)
				break;
		}
	}
	rf_emi_stop();
}

void emi_con_tx55(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
	rf_emi_tx_continue_setup(rf_mode,power,rf_chn,2);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode ))
	rf_continue_mode_run();
	rf_emi_stop();
}



void emi_con_tx0f(RF_ModeTypeDef rf_mode,unsigned char pwr,signed char rf_chn)
{
#ifdef ATE_SW_TEST
	RF_PowerTypeDef power = rf_power_Level_list_ate[pwr];
#else
	RF_PowerTypeDef power = rf_power_Level_list[pwr];
#endif
	rf_emi_tx_continue_setup(rf_mode,power,rf_chn,1);
	while( ((read_reg8(0x40006)) == run ) &&  ((read_reg8(0x40007)) == cmd_now )\
			&& ((read_reg8(0x40008)) == power_level ) &&  ((read_reg8(0x40009)) == chn )\
			&& ((read_reg8(0x4000a)) == mode ))
	rf_continue_mode_run();
	rf_emi_stop();
}



void emi_deepio_noren(RF_ModeTypeDef rf_mode,unsigned char pin,signed char rf_chn)
{
	rf_mode = rf_mode;
	rf_chn = rf_chn;
	if(gpio_map[pin]==GPIO_SYS) return;
	cpu_set_gpio_wakeup(gpio_map[pin], Level_High, 1);  //gpio pad wakeup
	gpio_setup_up_down_resistor(gpio_map[pin], PM_PIN_PULLDOWN_100K);
	cpu_sleep_wakeup(DEEPSLEEP_MODE , PM_WAKEUP_PAD,0);
}

void emi_deeptimer_noren(RF_ModeTypeDef rf_mode,unsigned char Sec,signed char rf_chn)
{
	rf_mode = rf_mode;
	rf_chn = rf_chn;
	cpu_sleep_wakeup(DEEPSLEEP_MODE , PM_WAKEUP_TIMER,(reg_system_tick+Sec*CLOCK_16M_SYS_TIMER_CLK_1S));
}

void emi_deeptimer_ren(RF_ModeTypeDef rf_mode,unsigned char Sec,signed char rf_chn)
{
	rf_mode = rf_mode;
	rf_chn = rf_chn;
	cpu_sleep_wakeup(DEEPSLEEP_MODE_RET_SRAM_LOW32K , PM_WAKEUP_TIMER,(reg_system_tick+Sec*CLOCK_16M_SYS_TIMER_CLK_1S));
}


void emi_deepio_ren(RF_ModeTypeDef rf_mode,unsigned char pin,signed char rf_chn)
{
	rf_mode = rf_mode;
	rf_chn = rf_chn;
	if(gpio_map[pin]==GPIO_SYS) return;
	cpu_set_gpio_wakeup(gpio_map[pin], Level_High, 1);  //gpio pad wakeup
	gpio_setup_up_down_resistor(gpio_map[pin], PM_PIN_PULLDOWN_100K);
	cpu_sleep_wakeup(DEEPSLEEP_MODE_RET_SRAM_LOW32K , PM_WAKEUP_PAD,0);
}


void emi_suspendio_noren(RF_ModeTypeDef rf_mode,unsigned char pin,signed char rf_chn)
{
	rf_mode = rf_mode;
	rf_chn = rf_chn;
	if(gpio_map[pin]==GPIO_SYS) return;
	cpu_set_gpio_wakeup(gpio_map[pin], Level_High, 1);  //gpio pad wakeup
	gpio_setup_up_down_resistor(gpio_map[pin], PM_PIN_PULLDOWN_100K);
	cpu_sleep_wakeup(SUSPEND_MODE , PM_WAKEUP_PAD,0);
}

void emi_suspendtimer_noren(RF_ModeTypeDef rf_mode,unsigned char Sec,signed char rf_chn)
{
	rf_mode = rf_mode;
	rf_chn = rf_chn;
	cpu_sleep_wakeup(SUSPEND_MODE , PM_WAKEUP_TIMER,(reg_system_tick+Sec*CLOCK_16M_SYS_TIMER_CLK_1S));
}

void user_init(void)
{
	emi_init();
}

void main_loop(void)
{
	emi_serviceloop();
}
#endif


