/********************************************************************************************************
 * @file     app.c 
 *
 * @brief    This is the source file for TLSR8278
 *
 * @author	 Driver Group
 * @date     May 8, 2018
 *
 * @par      Copyright (c) 2018, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *           The information contained herein is confidential property of Telink
 *           Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *           of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *           Co., Ltd. and the licensee or the terms described here-in. This heading
 *           MUST NOT be removed from this file.
 *
 *           Licensees are granted free, non-transferable use of the information in this
 *           file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 * @par      History:
 * 			 1.initial release(DEC. 26 2018)
 *
 * @version  A001
 *         
 *******************************************************************************************************/

#include "AAA_project_config.h"
#define MY_CHANNEL_ENABLE  1

t_mouse_inf mouse_inf,last_mouse_inf; 

u8 rx_fail=0;
u32 rx_tick=0;
u32 rx_mouse_cnt=0;
u32 mouse_to_pc_cnt=0;
u8 has_write_cfg=0;
u8 debug_report_rate=0;
u32 tick_pc_breath=0;
// aes mehtod
//0:no aes encryption   no key					old method
//1:aes128 encryption   User burn fixed key   	old method
//2:aes128 encryption	Dynamic random key
//attention :Dongle&KB must be set to the same encryption mode
#define AES_METHOD 2

#if ((AES_METHOD==0)||(AES_METHOD==1))
	#define id_len 4 
#elif (AES_METHOD==2)
	#define id_len 16 
#endif
typedef void (*callback_rx_func)(u8 *);
u8 * raw_pkt=NULL;
callback_rx_func p_post = NULL;
u8 bin_crc[4];


USB_FIFO_DATA_S  usb_fifo_aaa;
RF_RX_FIFO_DATA_S rf_rx_fifo_aaa;
//u8 sys_not_release=0;
//u8 consume_not_release=0;
u8 mouse_not_release=0;
//u8 normal_not_release=0;
u32 dongle_id=0;

u32 kb_tick=0;
u32 ms_tick=0;

 u8 allow_suspend = 0;
u32 tick_allow_suspend = 0;
u32 tick_host_start_power_on=0;
u32 tick_host_start_power_off=0;
u32 tick_suspend_interval;


u8 need_wake_up_host_flag=0;
u32 tick_resume_host;
u8 allow_send_to_usb_flag=1;

u8 encKey[16]={
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10};
u8 pub_key[16] =
{
	0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, 0x10
};

//pairing ack head: 80805113
rf_packet_ack_pairing_t	ack_pairing = {
		sizeof (rf_packet_ack_pairing_t) - 4,	// 0x14=24-4,dma_len

		sizeof (rf_packet_ack_pairing_t) - 5,	// 0x13=24-5,rf_len
		RF_PROTO_BYTE,							// 0x51,proto
		PKT_FLOW_DIR,							// 0x80,flow
		FRAME_TYPE_ACK,							// 0x80,type

		0,					// rssi
		0,					// per
		0,					// tick
		0,					// chn
		0,					// info0
		0,					// info1
		0,					// info2
		0xffffffff,			// gid1
		0xffffffff,			// device id
};
//ack mouse head: 81805109
rf_packet_ack_mouse_t	ack_mouse = {
		sizeof (rf_packet_ack_mouse_t) - 4,	// dma_len

		sizeof (rf_packet_ack_mouse_t) - 5,	// rf_len,0x09
		RF_PROTO_BYTE,						// proto,0x51
		PKT_FLOW_DIR,						// flow,0x80
		FRAME_TYPE_ACK_MOUSE,				// type,0x81

		0,					// rssi
		0,					// per
		0,					// tick

		0,					// chn
};
rf_packet_ack_keyboard_t	ack_keyboard = {
		sizeof (rf_packet_ack_keyboard_t) - 4,	// dma_len

		sizeof (rf_packet_ack_keyboard_t) - 5,	// rf_len 	0x09
		RF_PROTO_BYTE,		// proto 						0x51
		PKT_FLOW_DIR,		// flow 						0x80
		FRAME_TYPE_ACK_KEYBOARD,					// type 0x82

		0,					// rssi
		0,					// per
		0,					// tick

		0,					// chn
		0,					// status
};
rf_packet_debug_t	ack_debug = {
		sizeof (rf_packet_debug_t) - 4,	// dma_len,0x10

		sizeof (rf_packet_debug_t) - 5,	// rf_len,0x0f
		RF_PROTO_BYTE,					// proto,0x51
		PKT_FLOW_DIR,					// flow,0x80
		FRAME_TYPE_DEBUG,				// type,0x40

		0,					// rssi
		0,					// per
		0,					// tick

		0,					// chn
		0,					// info0
		0,					// info1
		0,					// info2

		U32_MAX,			// gid1
		U32_MAX,			// did,device id
};
rf_ack_empty_t	ack_empty = {
		sizeof (rf_ack_empty_t) - 4,			// 0x09,dma_len

		sizeof (rf_ack_empty_t) - 5,			// 0x08,rf_len
		RF_PROTO_BYTE,							// 0x51,proto
		PKT_FLOW_DIR,							// 0x80,flow
		FRAME_TYPE_ACK_EMPTY,					// 0xc0,type

		0,					// rssi
		0,					// per
		0,					// tick

		0,					// chn
};
//u8		chn_mask_fix = 0;
u8		chn_mask = 0x80;

frqHopping_data_t  frq_hopping_data = {
	FRQ_HOPPING_MODE_NORMAL,
	8,
	2,
	0,
	120000,
	0
};
unsigned char  rf_rx_buff[PKT_BUFF_SIZE*2] __attribute__((aligned(4)));
int		rf_rx_wptr;
u8		host_channel = 0;

u8		ll_rssi;
u16		ll_chn_tick;
u32		ll_chn_rx_tick;
u32		ll_chn_mask = LL_CHANNEL_SEARCH_FLAG;


u8		ll_chn_sel;
u8		ll_chn_pkt[16] = {0};
u32		ll_clock_time;
int		device_packet_received;

u8 *	p_debug_pkt = 0;


static u32 tick_last_tx;
static u32 tick_timer1_irq;
static u32 tick_8ms_cnt;


AES_KEY key_enc[2][8];
u8 device_index=0;

//int		mouse_idx;
//int		keyboard_idx;



u32 power_on_tick=0;
u8 rf_pair_enable=1;

custom_cfg_t user_config;


u32 rx_cnt_aaa=0;
u16 rf_state_aaa=0;
s8     manual_paring_enable;
s8     golden_dongle_enable;

int memcmp_aaa(const void * m1, const void *m2, unsigned int n) {

	unsigned char *s1 = (unsigned char *) m1;
	unsigned char *s2 = (unsigned char *) m2;

	while (n--) {
		if (*s1 != *s2) {
			return *s1 - *s2;
		}
		s1++;
		s2++;
	}
	return 0;
}
void aes_user_encryption( u8 *plaintext, u8 *encrypted_data)
{
	aes_encrypt(encKey, plaintext, encrypted_data);
}
 
void aes_user_decryption( u8 *encrypted_data, u8 *decrypted_data)
{
	aes_decrypt(encKey, encrypted_data, decrypted_data);
}
u8 test_key[16] =
{
	0x05, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, 0x10
};

u8 aes_user_set_key(rf_packet_mouse_t *p)
{
#if((AES_METHOD==2))
#if 1
	if(device_index>1)
	{
		return 0;
	}
	for(u8 i=0;i<user_config.bond_count;i++)
	{
		if((memcmp_aaa(&key_enc[device_index][i].did,&p->did,4))==0)
		{
			memcpy(encKey,&key_enc[device_index][i].did,id_len);
			return 1;
		}
	}


	return 0;
#else   //for test
	memcpy(encKey,test_key,16);
 return 1;
#endif


#elif ((AES_METHOD==1))
    memcpy(encKey,pub_key,16);
	return 1;
#else
	return 1;
#endif
	
}

#if 0
// key=1  2  3  4  5  6  7  8  9  a  b  c  d  e  f  10  
// src=1  2  3  4  5  6  7  8  9  a  b  c  d  e  f  10  
// enc=34  c3  3b  7f  14  fd  53  dc  ea  25  e0  1a  2  e1  67  27  
// dec=1  2  3  4  5  6  7  8  9  a  b  c  d  e  f  10 
void test_aes_user()
{
 u8 Key[16] ={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
 u8 src[16]= {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
 u8 enc_result[16];
 u8 dec_result[16];
 static u32 tick;
 while(1)
 {
  if(clock_time_exceed(tick,2000000))
  {
   tick=clock_time();
    printf ("key=");
   for(u8 i=0;i<16;i++)
   {
     printf ("%1x  ",Key[i]);
   }
   printf("\n");
   printf("src=");
   for(u8 i=0;i<16;i++)
   {
    printf("%1x  ",src[i]);
   }
   printf("\n");
   aes_user_encryption(Key,src,enc_result);
   printf("enc=");
   for(u8 i=0;i<16;i++)
   {
    printf("%1x  ",enc_result[i]);
   }
   printf("\n");
   aes_user_decryption(Key,enc_result,dec_result);
   printf("dec=");
   for(u8 i=0;i<16;i++)
   {
    printf("%1x  ",dec_result[i]);
   }
   printf("\n");
   printf("\r\n");
  }
 }
}
#endif
int flash_info_load_aaa(u32 s_addr, u8 *d_addr,  u8 len)
{
    int idx;
    u32 buf;
    for (idx = 0; idx < 4096; idx += len)
    {
        flash_read_page((u32)(s_addr + idx), 4, (u8 *)(&buf));
        if (buf == U32_MAX)
        {
            break;
        }
    }
    idx -= len;
    if (idx < 0) 		// no binding
    {
        return idx;
    }
    flash_read_page((u32)(s_addr + idx), len, d_addr);

    if (idx > 4000) 			//3k, erase flash
    {
        flash_erase_sector((u32)s_addr);

        sleep_us(10);

        flash_write_page((u32)s_addr, len, d_addr);
        idx = 0;
    }

    return idx;

}
void rf_set_channel_aaa(signed char chn, unsigned short set)
{
	//rf_set_channel(59,0);
	rf_set_channel (chn, set);
}
void clear_pair_enable_flag()
{
	rf_pair_enable=0;
	if(user_config.paring_type!=GOLDEN_DONGLE_PARING_TYPE)
	{
		rf_rx_acc_code_enable(0x06);//mouse&keboard
	}
}
void check_first_normal_data()
{
	static u32 first_rx_normal_data_tick=0;
	if(first_rx_normal_data_tick==0)
	{
		first_rx_normal_data_tick=clock_time()|1;
	}
	else if(rf_pair_enable&&clock_time_exceed(first_rx_normal_data_tick,1000000))
	{
		clear_pair_enable_flag();
	}
}


u8 push_usb_fifo_aaa(u8 type,u8 *buf,u8 len)
{
	USB_DATA_S *p=(USB_DATA_S*)usb_fifo_aaa.fifo[usb_fifo_aaa.wptr&(USB_FIFO_NUM-1)];
	p->type=type;
	memcpy(p->buf,buf,len);
	usb_fifo_aaa.wptr++;
	int fifo_use=(usb_fifo_aaa.wptr-usb_fifo_aaa.rptr)&(USB_FIFO_NUM*2-1);
	if(fifo_use>USB_FIFO_NUM)
	{
		usb_fifo_aaa.rptr++;//overlap older data
	}
	return 1;
}


u8 push_rf_rx_fifo_aaa(u8 *buf,u8 len)
{
	user_resume_host();
	memcpy(rf_rx_fifo_aaa.fifo[rf_rx_fifo_aaa.wptr&(RF_RX_FIFO_NUM-1)],buf,len);
	rf_rx_fifo_aaa.wptr++;
	int fifo_use=(rf_rx_fifo_aaa.wptr-rf_rx_fifo_aaa.rptr)&(RF_RX_FIFO_NUM*2-1);
	if(fifo_use>RF_RX_FIFO_NUM)
	{
		rf_rx_fifo_aaa.rptr++;//overlap older data
	}
	return 1;
}

static inline u32 rf_access_code_24to32 (u32 code)
{
 u32 r = (code & 0x00ffff00)>>8;
 u32 p = code & 0xff;
 u32 t = 0;
 for (int i=0; i<8; i++) {
  t = t << 2;
  t |= ((p & BIT(i)) ? 1 : 2);
  t = t << 2;
  t |= (r & 0x03);
  r = r >>2;
 }
 return t;
}

void set_pair_access_code(u32 code)
{
    write_reg32(0x800408, ((code & 0xffffff00) | 0x71));
    write_reg8(0x80040c, code);
}
void set_data_access_code(u32 code)
{
	write_reg32(0x800410, ((code & 0xffffff00) | 0x77));
    write_reg8(0x800414, code);
}
static inline u32 rf_get_access_code1 (void)
{
	return read_reg8 (0x800414) | (read_reg32(0x800410) & 0xffffff00);
}
void rf_user_init()
{
    rf_drv_init(RF_MODE_PRIVATE_2M);
	//reg_dma_chn_en|=FLD_DMA_CHN_RF_RX|FLD_DMA_CHN_RF_RX;
	p_debug_pkt = (u8 *) &ack_debug;
	rf_rx_buffer_set((u8*)rf_rx_buff,PKT_BUFF_SIZE,0);

	//rf_acc_len_set(5);
	write_reg8(0x405, (read_reg8(0x405)&0xf8) |5); //access_byte_num[2:0]
	//REG_RF_ACCESS_CODE_GTH = 38; //full bit match
	write_reg8(0x420, 38);
	
	rf_set_power_level_index(RF_POWER_P8p92dBm);

	 write_reg32(0x800408,0x39517671);  //for 8366
	 write_reg8(0x80040c,0x95);
	 
	 write_reg32(0x800410,0xd3f03577);  //for 8366
	 write_reg8(0x800414,0xe7);

	write_reg32(0x800418,0xc0300c03); //for 8366

#if 1
	write_reg16(0xf06, 0);//rx wait time
    write_reg8(0x0f0c, 0x54); //rx settle time: Default 150us, minimum 85us(0x54+1)

    write_reg16(0xf0e, 0);//tx wait time
    //write_reg8(0x0f04, 0x70);//tx settle time: Default 150us, minimum 113us(0x70+1)

    write_reg8(0xf10, 0);// wait time on NAK
#endif

#if 1//
	write_reg8(0x402,0x44);
#else 
	write_reg8(0x402,0x48);
#endif
#if 1
    if(user_config.rf_id!=0xffff)
    {
		set_pair_access_code(rf_access_code_16to32(user_config.rf_id));
    }
#else  //for test
	set_pair_access_code(rf_access_code_16to32(0x3333));
#endif

#if 1 
   
	
	set_data_access_code(dongle_id);
   
#else //for test
	set_data_access_code(rf_access_code_16to32(0x5555));
#endif

	
	rf_set_tx_rx_off();
	rf_rx_acc_code_enable(0X07);//
	rf_tx_acc_code_select(0);
	
	irq_disable();
	//irq_clr_src();
	rf_irq_clr_src(0xffff);
	irq_enable_type(FLD_IRQ_ZB_RT_EN);
	rf_irq_disable(FLD_RF_IRQ_ALL);
	rf_irq_enable(FLD_RF_IRQ_TX|FLD_RF_IRQ_RX);
	
	
}
_attribute_ram_code_ void rf_tx_irq_handle()
{
	//static irq_host_tx_no;
	//irq_host_tx_no++;
	//rf_tx_flag=0;
	tick_last_tx = clock_time ();
#if LL_HOST_RX_MULTI_RECEIVING_EN
	rf_multi_receiving_start (host_channel, RF_CHN_TABLE);
#else
	rf_set_channel_aaa (host_channel, RF_CHN_TABLE);
	rf_set_rxmode ();
#endif

	//reg_rf_irq_status = FLD_RF_IRQ_TX;
}
u8 get_device_id_from_ram(rf_packet_pairing_t *p,u8 len)
{
	u8 i=0;
	u8 type=p->type-FRAME_TYPE_MOUSE;
	device_index=0xff;
	for(i=0;i<user_config.bond_count;i++)
	{
		 for(u8 index=0;index<2;index++)
		 {
			if((memcmp_aaa(&key_enc[index][i].did,&p->did,len))==0)
			{
				device_index=index;
				return 1;
			}
		 }
	}
	return 0;
}
u8 check_from_ram(rf_packet_pairing_t *p)
{
	static u16 buf[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

	if((memcmp_aaa(buf,&p->did,id_len)))
	{
		memcpy(buf,&p->did,id_len);
		return 0;
	}
	return 1;
}



u8 save_to_flah(u8 type)
{
	u32 addr;
	u8 index;
	if(type==FRAME_TYPE_MOUSE)
	{
		addr=MOUSE_PARING_INFO_ADDR;
		index=0;
	}
	else
	{
		addr=KB_PARING_INFO_ADDR;
		index=1;
	}
	for(u8 i=0;i<8;i++)
	{
		flash_erase_sector(addr);
		flash_write_page(addr,id_len*user_config.bond_count,(u8*)&key_enc[index][0].did);
		static AES_KEY temp[8];
		flash_read_page(addr,id_len*user_config.bond_count,(u8*)&temp[0].did);
		if(memcmp_aaa((u8*)&temp[0], (u8*)&key_enc[index][0].did, id_len*user_config.bond_count)==0)
		{
			return 1;
		}
		
	 }	
	return 0;
}

int set_device_id_in_firmware (u8 *p)
{
	rf_packet_pairing_t *p_pkt = (rf_packet_pairing_t *)(p);
	u8 i=0;
	u8 j=0;
	u8 ret=0;
	u8 index=0;
	u8 dec[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#if ((AES_METHOD==0)||(AES_METHOD==1))	
	memcpy(&dec[0],&p_pkt->did,id_len);
#else
	//user_rijndaelSetKey(pub_key);
	memcpy(encKey,pub_key,16);
	aes_user_decryption((u8 *)&p_pkt->did,&dec[0]);
	
#endif
	if(p_pkt->type==FRAME_TYPE_MOUSE)
	{	
		index=0;
	}
	else
	{
		index=1;
	}
	for(i=0;i<user_config.bond_count;i++)
	{
		if(memcmp_aaa((u8*)&key_enc[index][i].did, dec, 4)==0)
		{
		    if(memcmp_aaa((u8*)&key_enc[index][i].did, dec, id_len)==0)
		    {
				return 1;
		    }
			else
			{
				memcpy((u8*)&key_enc[index][i].did,dec,id_len);
				ret=save_to_flah(p_pkt->type);
				return ret;
			}
		}
	}
	if(i==user_config.bond_count)
	{
		for(j=0;j<(user_config.bond_count-1);j++)
		{
			memcpy(&key_enc[index][j].did,&key_enc[index][j+1].did,id_len);
		}
		memcpy(&key_enc[index][user_config.bond_count-1].did,dec,id_len);
		ret=save_to_flah(p_pkt->type);
		return ret;
	}
	
	return 0;
}

_attribute_ram_code_ u8 *rf_pair_response(u8 *rx_packet)
{
	rf_packet_pairing_t *p_pkt=(rf_packet_pairing_t*)rx_packet;
	static u8 rx_id_same_cnt=0;
	if(user_config.paring_type==MANUAL_PARING_TYPE)
	{
		if((p_pkt->flow & PKT_FLOW_PARING)&&(rf_pair_enable))
		{
		#if PAIR_CHECK_RSSI_ENABLE_AAA
			static u32 rx_rssi = 0;
			static u8 rssi_last;
			u8 rssi_now=GET_RX_RSSI(rx_packet);
	        if(!rx_rssi){
	        	rx_rssi = rssi_now;
	        }
	        if ( abs_aaa(rssi_last - rssi_now) < 17 ){
	            rx_rssi = ( ( rx_rssi << 1) + rssi_now ) / 3   ;
	        }
	        rssi_last = rssi_now;
			if(rx_rssi>(50-user_config.rssi_threshold))
        #endif
    		{
			    if (check_from_ram(p_pkt)) //check ram
			    {
					rx_id_same_cnt++;
					if (rx_id_same_cnt>=2) 
					{
		                ack_pairing.gid1 = dongle_id;
		                //ack_pairing.did = p_pkt->did;
						memcpy(&ack_pairing.did,&p_pkt->did,id_len);
						
						p_post = (void *)set_device_id_in_firmware;
						
						return (u8 *) &ack_pairing;		//send ACK
		            }
			    }
				else
				{
					rx_id_same_cnt=0;
				}
				
				
		    }
		}
	}
	
	ack_empty.type = FRAME_PAIR_FAIL;
	return (u8 *) &ack_empty;
}

_attribute_ram_code_ u8 *rf_normal_data_response(u8 *rx_packet)
{
	rf_packet_mouse_t *p_pkt=(rf_packet_mouse_t*)rx_packet;
	static u8 ms_seq_no=0xff;
	static u8 kb_seq_no=0xff;

	
	u8 data_valid=get_device_id_from_ram((rf_packet_pairing_t *)p_pkt,4);
	if(user_config.paring_type==GOLDEN_DONGLE_PARING_TYPE)
	{
	#if GLOD_DONGLE_RSSI_ENABLE_AAA
		if(GET_RX_RSSI(rx_packet)>(65-user_config.rssi_threshold))
		{
			data_valid=1;
		}
	#else
		data_valid=1;
	#endif
	}
	if(data_valid)
	{
		check_first_normal_data();
		if (p_pkt->type == FRAME_TYPE_MOUSE)  //mouse
		{
			frq_hopping_data.device_pktRcv_flg |= PKT_RCVD_FLG_MOUSE;
			frq_hopping_data.mouse_pktRcv_sysTick = clock_time();
			
			mouse_inf.sensor_inf=p_pkt->sensor_inf;
			mouse_inf.bat=p_pkt->bat_value;
			mouse_inf.report_rate=p_pkt->pno>>4;
			#if 0
			if(has_write_cfg==0)
			{
				ack_mouse.info=((sensor_info>>5)|(mouse_report_rate<<4));
			}
			else
			{
				has_write_cfg=0;
			}
			#endif
			
			if(p_pkt->seq_no!=ms_seq_no)
			{
				ms_seq_no=p_pkt->seq_no;
				push_rf_rx_fifo_aaa(rx_packet,sizeof(rf_packet_mouse_t));	
			}
			return (u8 *) &ack_mouse;
		}
		else//keybaord
		{
			
			frq_hopping_data.device_pktRcv_flg |= PKT_RCVD_FLG_KB;
			ack_keyboard.status = host_keyboard_status;
			
			if(p_pkt->seq_no!=kb_seq_no)
			{
				kb_seq_no=p_pkt->seq_no;
				push_rf_rx_fifo_aaa(rx_packet,sizeof(rf_packet_keyboard_t));	
			}
			return (u8 *) &ack_keyboard;
		}
		
	}
	return 0;
}
 #if (MY_CHANNEL_ENABLE==0)
u8	get_next_channel_with_mask(u32 mask, u8 chn)
{
	int chn_high = (mask >> 4) & 0x0f;

	if (mask & LL_CHANNEL_SEARCH_FLAG) {
		return LL_NEXT_CHANNEL (chn);
	}
	else if (chn_high != chn) {
		ll_chn_sel = 1;
		return chn_high;
	}
	else {
		ll_chn_sel = 0;
		return mask & 0x0f;
	}
}
u32	tick_fh = 0;
u32	fh_num = 0;
u8	update_channel_mask(u32 mask, u8 chn, u8* chn_pkt)
{
	static int ll_chn_sel_chg, ll_chn_hold;

#if 1//CHANNEL_HOPPING_ALWAYS
	if (device_packet_received == 1) {
		tick_fh = clock_time ();
	}
	else if (clock_time_exceed(tick_fh, frq_hopping_data.fre_hp_always_time_us))  {
		chn_pkt[ll_chn_sel_chg] = 0;
		chn_pkt[!ll_chn_sel_chg] = frq_hopping_data.frq_hp_chn_pkt_rcvd_max;
	}
#endif

	if (ll_chn_hold) {
		ll_chn_hold--;
		chn_pkt[0] = chn_pkt[1] = 0;
	}
	int diff = chn_pkt[ll_chn_sel] - chn_pkt[!ll_chn_sel];
	int hit_th = diff > frq_hopping_data.frq_hp_hit_diff_num;
	if (chn_pkt[ll_chn_sel] >= frq_hopping_data.frq_hp_chn_pkt_rcvd_max || hit_th) {
		int dual_chn[2];
		dual_chn[0] = mask & 0x0f;
		dual_chn[1] = mask >> 4;
		if (hit_th) { //change channel
			ll_chn_hold = 4;
			chn = dual_chn[!ll_chn_sel];
			for (int i=0; i<8; i++) {
				chn = LL_NEXT_CHANNEL (chn);
				if ((ll_chn_sel && chn != dual_chn[1])) {
					mask = (mask & 0xf0) | chn;
					break;
				}
				else if (!ll_chn_sel && chn != dual_chn[0]) {
					mask = (mask & 0x0f) | (chn << 4);
					break;
				}
			}
			tick_fh = clock_time ();
			fh_num++;
			ll_chn_sel_chg = !ll_chn_sel;		//remember latest channel change
		}
		chn_pkt[0] = chn_pkt[1] = 0;
	}

	return mask;
}

static inline void frq_hopping_mode_switch(void)
{
#if(FRQ_HOPPING_MODE_SWITCH_ENABLE)
	if(frq_hopping_data.frq_hp_mode == FRQ_HOPPING_MODE_NORMAL){  //normal hopping
		if(KB_PKT_COME){
			if(MOUSE_PKT_NEVER_COME || MOUSE_PKT_5S_NO_COME){
				frq_hopping_data.frq_hp_mode = FRQ_HOPPING_MODE_SLOW;
				frq_hopping_data.frq_hp_chn_pkt_rcvd_max = 10;
				frq_hopping_data.frq_hp_hit_diff_num = 8;
				frq_hopping_data.fre_hp_always_time_us = 3000000;
			}
		}
	}
	else{  //slow hopping
		if(MOUSE_PKT_COME){
			frq_hopping_data.frq_hp_mode = FRQ_HOPPING_MODE_NORMAL;
			frq_hopping_data.frq_hp_chn_pkt_rcvd_max = 8;
			frq_hopping_data.frq_hp_hit_diff_num = 2;
			frq_hopping_data.fre_hp_always_time_us = 120000;
		}
	}
	frq_hopping_data.device_pktRcv_flg &= (~PKT_RCVD_FLG_MOUSE_KB_LOCAL);
#endif
}

 void irq_host_timer1 (void)
 {
	//log_event (TR_T_irq_timer1);
	tick_timer1_irq++;
	if (device_packet_received == 1) {
		ll_chn_pkt[ll_chn_sel]++;
	}
#if 1//(!__PROJECT_DONGLE_8510__)
	//if(dongle_support_keyboard_enable)
	{
		frq_hopping_mode_switch();
	}
#endif
	host_channel = get_next_channel_with_mask (chn_mask, host_channel);

	//if (chn_mask_fix) {
	//	chn_mask = chn_mask_fix;
//	}
//	else 
	{
		chn_mask = update_channel_mask(chn_mask, host_channel, ll_chn_pkt);
	}
	device_packet_received = 0;
#if 0
	//log_data (TR_24_rf_channel, host_channel);
	if (p_debug_pkt && clock_time_exceed (tick_last_tx, 500000)) {
		//rf_stop_trx ();
		rf_set_channel_aaa (15, RF_CHN_TABLE);
		//rf_set_tx_pipe (PIPE_MOUSE);
		//RF_TX_PA_POWER_LEVEL (0);
		((rf_packet_ack_pairing_t *)p_debug_pkt)->tick = reg_tmr1_tick;
		((rf_packet_ack_pairing_t *)p_debug_pkt)->chn = chn_mask;
		((rf_packet_ack_pairing_t *)p_debug_pkt)->info1++;
		//rf_multi_receiving_send_packet (p_debug_pkt);
		rf_set_power_level_index (RF_POWER_LEVEL_MIN);
		rf_send_single_packet (p_debug_pkt);
		//TxPkt (p_debug_pkt);
		tick_last_tx = clock_time ();
	}
	else 
#endif		
	{
#if LL_HOST_RX_MULTI_RECEIVING_EN
		rf_multi_receiving_start (host_channel, RF_CHN_TABLE);
#else
		rf_set_channel_aaa (host_channel, RF_CHN_TABLE);
		rf_set_rxmode ();
#endif
	}
}
#else
void irq_host_timer1 (void)
{
	rf_channel_poll();
	tick_8ms_cnt++;
	if(tick_8ms_cnt>=50)
	{
		tick_8ms_cnt=0;
		if(debug_report_rate)
		{
			USB_PC_DEVICE buf;
			buf.len=9;
			buf.type=DEBUG_REPORT_RATE_CMD;
			rx_mouse_cnt=rx_mouse_cnt*5/2;
			memcpy(buf.buf,(u8*)&rx_mouse_cnt,4);
			mouse_to_pc_cnt=mouse_to_pc_cnt*5/2;
			memcpy(&buf.buf[4],(u8*)&mouse_to_pc_cnt,4);
			
			spp_push_data((USB_PC_DEVICE *)&buf,(DEVICE_PC_FIFO_DATA_S *)&to_pc_dat);
		}
		rx_mouse_cnt=0;
		mouse_to_pc_cnt=0;
	}		
	
}

#endif

_attribute_ram_code_ void rf_rx_irq_handle()
{
	u8 * p_ack=0;
	raw_pkt = (u8 *) (rf_rx_buff + rf_rx_wptr * PKT_BUFF_SIZE);
	rf_rx_wptr = (rf_rx_wptr + 1) & 1;
	rf_rx_buffer_set((u8*)(rf_rx_buff + rf_rx_wptr * PKT_BUFF_SIZE),PKT_BUFF_SIZE,0);
	if(RF_NRF_ESB_PACKET_CRC_OK(raw_pkt)&&RF_NRF_ESB_PACKET_LENGTH_OK(raw_pkt))
	{
		rf_set_tx_rx_off();
		u8 pipe=(raw_pkt[raw_pkt[0]+1]&0x70)>>4;
		rf_packet_pairing_t *p_pkt=(rf_packet_pairing_t*)raw_pkt;
		if(p_pkt->proto==RF_PROTO_BYTE)
		{
			
			rf_set_tx_pipe(pipe);
			#if 1
			if(pipe==PIPE_PARING)
			{
				p_ack=rf_pair_response(raw_pkt);
			}
			else if(((pipe==PIPE_MOUSE)&&(p_pkt->type==FRAME_TYPE_MOUSE))||((pipe==PIPE_KEYBOARD)&&(p_pkt->type==FRAME_TYPE_KEYBOARD)))
			{
				p_ack=rf_normal_data_response(raw_pkt);
			}
			
			if(p_ack==0) 
			{
				p_ack=(u8*)&ack_debug;
			}
			#if MY_CHANNEL_ENABLE
			tick_timer1_irq++;
			#endif
			((rf_packet_ack_pairing_t *)p_ack)->rssi = GET_RX_RSSI(raw_pkt);
			((rf_packet_ack_pairing_t *)p_ack)->chn = chn_mask;
			((rf_packet_ack_pairing_t *)p_ack)->per =
					(ll_chn_pkt[0] & 0xf) | ((ll_chn_pkt[1] & 0xf) << 4) ;
			//((rf_packet_ack_mouse_t *)p_ack)->info = fh_num;
		#if(CLOCK_SYS_CLOCK_HZ == 48000000)
			((rf_packet_ack_pairing_t *)p_ack)->tick = ((reg_tmr1_tick * 170 >> 18) & 0xff) |
													((tick_timer1_irq & 0xff) << 8);
				
		#elif(CLOCK_SYS_CLOCK_HZ == 32000000)
			((rf_packet_ack_pairing_t *)p_ack)->tick = ((reg_tmr1_tick >> 10) & 0xff) |
													((tick_timer1_irq & 0xff) << 8);
		#elif(CLOCK_SYS_CLOCK_HZ == 24000000)
			((rf_packet_ack_pairing_t *)p_ack)->tick = ((reg_tmr1_tick * 170 >> 17) & 0xff) |
													((tick_timer1_irq & 0xff) << 8);
		#else				// 16 MHz
			((rf_packet_ack_pairing_t *)p_ack)->tick = ((reg_tmr1_tick >> 9) & 0xff) |
										((tick_timer1_irq & 0xff) << 8);
		#endif
			#endif
			
			rx_tick=clock_time()|1;
			rx_fail=0;
			rf_state_aaa=1;
		}
		else
		{
			ack_empty.type = FRAME_NO_PAIR_FLOW;
			p_ack=(u8*)&ack_empty;
		}
		rf_start_stx ((void *)p_ack, clock_time()+10* CLOCK_16M_SYS_TIMER_CLK_1US);
         raw_pkt[0] = 1;
		device_packet_received++;
	}
}

void custom_init()
{
	flash_read_page(CFG_ADR_MAC, sizeof(custom_cfg_t),(u8*)&user_config.mac_addr);
	if(user_config.mac_addr==U32_MAX)
	{
		generateRandomNum(4, (u8*)&user_config.mac_addr);
		flash_write_page(CFG_ADR_MAC, 4, (u8*)&user_config.mac_addr);
	}
	dongle_id = rf_access_code_24to32(user_config.mac_addr);
	

    for (u8 i = 0; i < 16; i++)
    {
        if (user_config.encKey[0]!= 0xff)
        {
            memcpy(encKey, &user_config.encKey[0], 16);
            break;
        }
    }


	if(user_config.paring_type==0xff)
	{
		user_config.paring_type=MANUAL_PARING_TYPE;
	}
	if(user_config.paring_limit_t==0xff)
	{
		user_config.paring_limit_t=60;
	}
	
	if(user_config.rssi_threshold==U8_MAX)
	{
		user_config.rssi_threshold=0;
	}
	if(user_config.bond_count==U8_MAX)
	{
		user_config.bond_count=1;
	}
	else if(user_config.bond_count>8)
	{
		user_config.bond_count=8;
	}



	user_config.support_type=SUPPORT_KEYBOARD_DEVICE;//support keyboard
#if USB_DESCRIPTOR_MY_SELF
	custom_set_usb_cfg_params(&user_config);
#endif

	//mouse_idx=flash_info_load_aaa(MOUSE_PARING_INFO_ADDR,(u8*)&mouse_id[0],32);
	//keyboard_idx=flash_info_load_aaa(KB_PARING_INFO_ADDR,&keyboard_id[0],32);
    flash_read_page(MOUSE_PARING_INFO_ADDR, id_len*user_config.bond_count, (u8*)&key_enc[0]);
	flash_read_page(KB_PARING_INFO_ADDR, id_len*user_config.bond_count, (u8*)&key_enc[1]);

}
void usb_custom_init()
{


	
	//enable USB manual interrupt(in auto interrupt mode,USB device would be USB printer device)
	usb_init_interrupt();
#if USB_DESCRIPTOR_MY_SELF
    if(user_config.support_type==SUPPORT_KEYBOARD_DEVICE)
    {
		write_reg8(0x10e,(1<<USB_EDP_MOUSE)|(1<<USB_EDP_KEYBOARD_IN)|(1<<USB_EDP_SPP_IN)|(1<<USB_EDP_SPP_OUT));
     
		
		//set ep3 BUSY(BUSY same as ACK) bit as 1 means output endpoint buffer can receive data from USB host
		//usbhw_data_ep_ack(3);
    }
	else
	{
		write_reg8(0x10e,(1<<USB_EDP_MOUSE)|(1<<USB_EDP_SPP_IN)|(1<<USB_EDP_SPP_OUT));
     
	}
#endif
	deepsleep_dp_dm_gpio_low_wake_enable();

	//enable USB DP pull up 1.5k
	usb_set_pin_en();
	
}
void timer1_init_aaa()
{
	timer1_set_mode(TIMER_MODE_SYSCLK,0,8* CLOCK_SYS_CLOCK_1MS);
	timer_start(TIMER1);
}

void get_bin_crc()
{
	u32 bin_size = 0;
	flash_read_page(0x18, 4, (u8 *)&bin_size);
	flash_read_page((bin_size - 4), 4, (u8 *)&bin_crc[0]);
}
void user_init()
{
	//test_aes_user();
	//test_time_wake_up_suspend();

	

	rf_user_init();

	timer1_init_aaa();
	

   usb_custom_init();

   get_bin_crc();
   
   irq_enable();
   power_on_tick=clock_time()|1;
}
#if 0
#define TEST_HID  0//0:KEBOARD 1: counsume  2:mouse move  3:sysytem key
u8 test_rf_data[64]={0};

void test_mouse_kb_hid_push()
{
    static u32 tick;
     static u8 flag = 0;
	static u32 interval=1000000;
	if(clock_time_exceed(tick, interval))
	{
		tick=clock_time();
	}
	else
	{
		return;
	}
#if (TEST_HID==0)  //test keyboard
	interval=1000000;
    rf_packet_keyboard_t *rf_kb=(rf_packet_keyboard_t *)test_rf_data;
	kb_data_t kb_data;
	rf_kb->pno=1;
	rf_kb->type=FRAME_TYPE_KEYBOARD;
	if(flag==1)
	{
		kb_data.cnt=2;
		kb_data.ctrl_key=1;
		kb_data.keycode[0]=0x04;//a
		kb_data.keycode[1]=0xb3;//vol
	}
	else if(flag==2)
	{
		kb_data.cnt=0;
	}
	else if(flag==3)
	{
		kb_data.cnt=2;
		kb_data.ctrl_key=2;
		kb_data.keycode[0]=0x05;//b
		kb_data.keycode[1]=0xb4;//vol
	}
	else if(flag==4)
	{
		kb_data.cnt=0;
	}
	else
	{
		flag=0;
	}
	flag++;
	memcpy(&rf_kb->data[0], &kb_data.cnt, 8);
	push_rf_rx_fifo_aaa((u8*)&rf_kb->dma_len, sizeof(rf_packet_keyboard_t));
#elif (TEST_HID==2)
	interval=4000;
    rf_packet_mouse_t *rf_ms=(rf_packet_mouse_t *)test_rf_data;
	rf_ms->pno=1;
	rf_ms->type=FRAME_TYPE_MOUSE;
	static mouse_data_t ms_data;
	 static int x = 0;
	  int step = 4;
    x++;
    if (x >= 50)
    {
        x = 0;
        flag++;
        if (flag > 3)
        {
            flag = 0;
        }
    }
    if (flag == 0)
    {
        ms_data.x = step;
        ms_data.y = 0;
    }
    else if (flag == 1)
    {
        ms_data.x = 0;
        ms_data.y = step;
    }
    else if (flag == 2)
    {
        ms_data.x = -step;
        ms_data.y = 0;
    }
    else if (flag == 3)
    {
        ms_data.x = 0;
        ms_data.y = -step;
    }
     memcpy(rf_ms->data,&ms_data.btn, 6);
	push_rf_rx_fifo_aaa((u8*)&rf_ms->dma_len, sizeof(rf_packet_mouse_t));
#endif
}
#endif
const u16 consumer_list[]={
0x221,		//0xa3 C_WWW_SEARCH		
0x223,		//0xa4 C_WWW_HOME
0x224,		//0xa5 C_WWW_BACKWARD
0x225,		//0xa6 C_WWW_FORWARD
0x226,		//0xa7 C_WWW_STOP
0x227,		//0xa8 C_WWW_REFRESH
0x22A,		//0xa9 C_MY_FAVORITE
0x183,		//0xaa C_MEDIA_SELECT
	
0x18A,		//0xab C_EMAIL
0x192,		//0xac C_CALCULATOR
0x194,		//0xad C_MY_COMPUTER
0xB5,		//0xae C_NEXT_TRACK
0xB6,		//0xaf C_PRE_TRACK
0xB7,		//0xb0 C_STOP
0xCD,		//0xb1 C_PLAY_PAUSE
0xE2,		//0xb2 C_MUTE	
	
0xE9,		//0xb3 C_VOL_INC
0xEA,		//0xb4 C_VOL_DEC	
0x00,		//0xb5 telinkԶ
0x22D,		//0xb6 USAGE ZOOM IN
0x22E,		//0xb7	 USAGE ZOOM OUT 
0x236,		//0xb8	 USAGE PAN LEFT
0x237,		//0xb9	 USAGE PAN RIGHT
0x30B,		//0xba	C_BRIGHT_INC	
	
0x30A,		//0xbb	C_BRIGHT_DEC
0xB8,		//0Xbc	 c_rject
0x30,		//0Xbd	C_POWER 		
0x19E,		//0Xbe	C_TERMINAL_LOCK 
};


u8 has_consume_key_press=0;
u8 has_normal_key_press=0;
u8 has_system_key_press=0;

u8 kb_data_handle(u8 *buf)
{
	
	u16 consume_key=0;
	u8 system_key=0;
	u8 normal_key[8]={0,0,0,0,0,0,0,0};
	u8 cnt=0;
	kb_data_t *kb=(kb_data_t *)buf;
	normal_key[0]=kb->ctrl_key;
	kb_tick=clock_time()|1;

	 if(kb->cnt==0)
	 {
	 	if(kb->ctrl_key)
	 	{
			has_normal_key_press=1;
			push_usb_fifo_aaa(NORMAL_KB_DATA_TYPE, normal_key, 8);
			return 1;
	 	}
		else
		{
			if(has_normal_key_press)
			{
				push_usb_fifo_aaa(NORMAL_KB_DATA_TYPE, normal_key, 8);
				has_normal_key_press=0;
			}
			if(has_consume_key_press)
			{
				push_usb_fifo_aaa(CONSUME_DATA_TYPE, (u8*)&consume_key, 2);
				has_consume_key_press=0;
			}
			if(has_system_key_press)
			{
				push_usb_fifo_aaa(SYSTEM_DATA_TYPE, &system_key, 1);
				has_system_key_press=0;
			}
			
		}
	 }
	 else
	 {
		cnt=2;
		for(u8 i=0;i<kb->cnt;i++)
		{
			if((kb->keycode[i]>=0xa0)&&(kb->keycode[i]<=0xa2))
			{
				system_key=1<<(kb->keycode[i]-0xa0);
				has_system_key_press=1;
				
			}
			else if((kb->keycode[i]>=0xa3)&&(kb->keycode[i]<=0xbe))
			{
				consume_key=consumer_list[kb->keycode[i]-0xa3];
				has_consume_key_press=1;
			}
			else
			{
				normal_key[cnt]=kb->keycode[i];
				cnt++;
				has_normal_key_press=1;
			}
		}
		if(has_normal_key_press)
		{
			push_usb_fifo_aaa(NORMAL_KB_DATA_TYPE, normal_key, 8);
			
		}
		if(has_consume_key_press)
		{
			push_usb_fifo_aaa(CONSUME_DATA_TYPE, (u8*)&consume_key, 2);
			
		}
		if(has_system_key_press)
		{
			push_usb_fifo_aaa(SYSTEM_DATA_TYPE, &system_key, 1);
			
		}
		
	}
	return 1;
}
ENC_RF_DATA dec;

void pull_rf_rx_data()
{
	u8 success=0;
	if(rf_rx_fifo_aaa.wptr!=rf_rx_fifo_aaa.rptr)
    {
		rf_packet_mouse_t *p=(rf_packet_mouse_t*)rf_rx_fifo_aaa.fifo[rf_rx_fifo_aaa.rptr&(RF_RX_FIFO_NUM-1)];
        u8 *p_src=(u8*)&p->dat;
		u8 count=p->pno&0x0f;
		#if (AES_METHOD==0)
			u8 *p_dec=(u8*)&dec.buf;
			memcpy(&p_dec[0],&p_src[0],16);
		#elif(AES_METHOD==1)
			u8 *p_dec=(u8*)&dec.buf;
			aes_user_set_key(p);
			aes_user_decryption(&p_src[0],&p_dec[0]);
		#else
			u8 *p_dec=(u8*)&dec.device_id;
			if(aes_user_set_key(p))
			{
				aes_user_decryption(&p_src[0],&p_dec[0]);
				aes_user_decryption(&p_src[16],&p_dec[16]);
				if(dec.device_id!=p->did)
				{
					rf_rx_fifo_aaa.rptr++;
					return;
				}
			}
			else
			{
				rf_rx_fifo_aaa.rptr++;
				return;
			}
			
			
		#endif
		

		if(p->type==FRAME_TYPE_MOUSE)
		{
			
			for(u8 i=0;i<count;i++)
			{
				u8* buf=&dec.buf[i*sizeof(mouse_data_t)];
				u8 now=special_btn_process(buf[0]);
				buf[0]=now;
				rx_mouse_cnt++;
				success|=push_usb_fifo_aaa(MOUSE_DATA_TYPE,buf,sizeof(mouse_data_t));
			}
		}
		else if(p->type==FRAME_TYPE_KEYBOARD)
		{
			
			for(u8 i=0;i<count;i++)
			{
				 success|=	kb_data_handle(&dec.buf[i*sizeof(kb_data_t)]);
			}
		}
		else
		{
			success|=1;
		}
		if(success)
		{
			rf_rx_fifo_aaa.rptr++;
		}
    }
}

void pull_usb_data()
{
	static u8 mouse_last_data[6]={0,0,0,0,0,0};	
	
	static u8 consume_last_data[2]={0,0};	
	static u8 sys_last_data=0;	
	static u8 normal_last_data[8]={0,0,0,0,0,0,0,0};
	
	int success=1;
	if(usb_fifo_aaa.wptr!=usb_fifo_aaa.rptr)
	{
		USB_DATA_S *p=(USB_DATA_S*)usb_fifo_aaa.fifo[usb_fifo_aaa.rptr&(USB_FIFO_NUM-1)];

		if(p->type==MOUSE_DATA_TYPE)
		{
            
			if(memcmp_aaa(mouse_last_data, p->buf,6)||(p->buf[1]!=0)||(p->buf[2]!=0)||(p->buf[3]!=0)||(p->buf[4]!=0)||(p->buf[5]!=0))
			{
				memcpy(mouse_last_data, p->buf,6);
				success=usb_mouse_hid_report_aaa(1,p->buf, 6);
				if(success)
				{
					mouse_to_pc_cnt++;
				}
			}
			
     		if((mouse_last_data[0]==0)&&(mouse_last_data[5]==0))
			{
				mouse_not_release=0;
			}
			else
			{
				mouse_not_release=1;
			}
			ms_tick=clock_time();
		}
		else if(p->type==NORMAL_KB_DATA_TYPE)
		{
			if(memcmp_aaa(normal_last_data, p->buf,8))
			{
				memcpy(normal_last_data, p->buf,8);
				success=usb_keyboard_hid_report_aaa(p->buf);
			}
			
			
		}
		else if(p->type==CONSUME_DATA_TYPE)
		{
			
			if(memcmp_aaa(consume_last_data, p->buf,2))
			{
				memcpy(consume_last_data, p->buf,2);
				success=usb_mouse_hid_report_aaa(2,p->buf, 2);
			}
			
		}
		else if(p->type==SYSTEM_DATA_TYPE)
		{
			if(sys_last_data!=p->buf[0])
			{
				sys_last_data=p->buf[0];
				success=usb_mouse_hid_report_aaa(3,p->buf, 1);
			}
			
			
		}
		if(success)
		{
			usb_fifo_aaa.rptr++;
		}
	}
    
    {
		u8 release_data[8] = {0,0,0,0,0,0,0,0};
		if(mouse_not_release&&clock_time_exceed(ms_tick,2000000))
		{
			if(usb_mouse_hid_report_aaa(1,release_data, 6))
			{
				mouse_not_release=0;
			}
		}
		else if(has_consume_key_press&&clock_time_exceed(kb_tick,2000000))
		{
			if(usb_mouse_hid_report_aaa(2,release_data, 2))
			{
				has_consume_key_press=0;
			}
		}
		else if(has_system_key_press&&clock_time_exceed(kb_tick,2000000))
		{
			if(usb_mouse_hid_report_aaa(3,release_data, 1))
			{
				has_system_key_press=0;
			}
		}
		
		if(has_normal_key_press&&clock_time_exceed(kb_tick,2000000))
		{
			if(usb_keyboard_hid_report_aaa(release_data))
			{
				has_normal_key_press=0;
			}
		}
		
    }
	
}
void notify_usb()
{
	pull_rf_rx_data();
	pull_usb_data();
}
void check_kb_led_status()
{
#if USER_DEBUG
	static u8 last_led_status=0xff;
	if(last_led_status!=host_keyboard_status)
	{
		last_led_status=host_keyboard_status;
		gpio_write(D1_LED_PIN, last_led_status&0x01);
		gpio_write(D2_LED_PIN, last_led_status&0x02);
		gpio_write(D3_LED_PIN, last_led_status&0x04);
	}
#endif	
}
void clear_enter_suspend_flag()
{
	allow_suspend=0;
	tick_allow_suspend=0;
}
void mcu_enter_suspend()
{
	if(clock_time_exceed (tick_suspend_interval, 40000))
	{
		#if 1
		//usb_dp_pullup_en (0);
		//gpio_write(D4_LED_PIN, 0);// usb hck test must pm_wakeup_core 
		 u8 r=irq_disable();
		if (reg_usb_mdev & BIT(2)) 
		{
			cpu_sleep_wakeup (SUSPEND_MODE, PM_WAKEUP_CORE| PM_WAKEUP_TIMER, clock_time()+400*CLOCK_16M_SYS_TIMER_CLK_1MS);
		}
		else 
		{
			cpu_sleep_wakeup (SUSPEND_MODE ,PM_WAKEUP_TIMER, clock_time()+400*CLOCK_16M_SYS_TIMER_CLK_1MS);
		}	
		
		//gpio_write(D4_LED_PIN, 1);
		
		rf_user_init();
	
		timer1_init_aaa();
		
		//usb_irq_init();
		irq_restore(r);
		tick_suspend_interval = clock_time()|1;
		irq_enable();
		#endif
		//led_flag^=0xff;
	   
		
	}
}
void user_resume_host()
{  
	if(reg_irq_src & FLD_IRQ_USB_PWDN_EN)
	{
		need_wake_up_host_flag=1;
		clear_enter_suspend_flag();
	}
	
	
}
void proc_suspend (void)
{
	
    u8 power_off_flag=0; 
	if(reg_irq_src & FLD_IRQ_USB_PWDN_EN)
	{
		power_off_flag=1;
	}
#if USER_DEBUG
	gpio_write(D5_LED_PIN, !power_off_flag);
#endif

	if(power_off_flag)
	{
		tick_host_start_power_on=clock_time()|1;
		
		host_keyboard_status=0;
		allow_send_to_usb_flag=0;

		if(tick_host_start_power_off)
		{
			if(clock_time_exceed(tick_host_start_power_off, 3000000))
			{
				tick_host_start_power_off=0;
				tick_resume_host=clock_time()+1000000*16;
				tick_suspend_interval=tick_resume_host;
				allow_suspend=1;
			}
			else
			{
				need_wake_up_host_flag=0;
			}
		}
        else if(need_wake_up_host_flag)
		{
			if(tick_resume_host==0)
			{
				tick_resume_host=clock_time()|1;
			}
			if(clock_time_exceed(tick_resume_host,1000000))
			{
				tick_resume_host=0;
				usb_resume_host();
			}	
		}
		else if(allow_suspend)
		{
			mcu_enter_suspend();
		}
		
	}
	else
	{
		tick_host_start_power_off=clock_time()|1;
		
		tick_allow_suspend=clock_time()|1;
		allow_suspend=0;
		
		need_wake_up_host_flag=0;
		tick_resume_host=0;

        if (tick_host_start_power_on&&clock_time_exceed(tick_host_start_power_on, 1000000))
        {
            allow_send_to_usb_flag = 1;
			u8 release_data[8] = {0,0,0,0,0,0,0,0};
			usb_mouse_hid_report_aaa(1,release_data,6);
			//usb_keyboard_hid_report_aaa(release_data);
			tick_host_start_power_on=0;
        }
		
	}


}
#if 0
void test_usb_chaba()
{
	static u32 tick;
	static u8 flag=0;
	if(clock_time_exceed(tick, 10000000))
	{
		tick=clock_time();
		usb_dp_pullup_en(0);
		sleep_us(20000);
		usb_dp_pullup_en(1);
		flag^=0xff;
		gpio_write(D5_LED_PIN,flag);
		usb_g_config=0;
	}
	gpio_write(D4_LED_PIN, reg_usb_host_conn);
}
#endif
void test_rf_rx_led_show()
{
#if USER_DEBUG
    static u32 tick=0;
    static u8 flag=0;

	if(clock_time_exceed(tick,100000))
	{
		tick=clock_time();
		if(rf_state_aaa)
		{
			rf_state_aaa=0;
			flag^=0xff;
			
		}
		else
		{
			flag=0;	
		}
		gpio_write(D4_LED_PIN, flag);
	}
	
	
#endif
}
void check_pair_timeout()
{
	if(power_on_tick&&clock_time_exceed(power_on_tick, user_config.paring_limit_t*1000000))
	{
		power_on_tick=0;
		clear_pair_enable_flag();
	}
}
_attribute_ram_code_ void rf_channel_poll()
{
#if MY_CHANNEL_ENABLE
	static u8 flag=0;
	rx_fail++;

	//if(clock_time_exceed(rx_tick,16000))
	if(rx_fail>1)
	
	{
		flag^=0xff;
   		gpio_write(RF_CHAN_CHANGE_PIN,flag);
		//rx_tick=clock_time()|1;
		rx_fail=0;
		host_channel=(host_channel+7)%21;
		rf_set_channel_aaa (host_channel, RF_CHN_TABLE);
		
		rf_set_rxmode ();
	}
#endif
}
void check_pc_breath()
{
	if(tick_pc_breath&&clock_time_exceed(tick_pc_breath,15000))
	{
		ack_mouse.info=0;
		tick_pc_breath=0;
	}
}
void check_mouse_inf_change()
{
	if(memcmp((u8*)&mouse_inf,(u8*)&last_mouse_inf,sizeof(t_mouse_inf)))
	{
		USB_PC_DEVICE buf;
		
		buf.len=sizeof(t_mouse_inf)+1;
		buf.type=MOUSE_INF_CMD;
		memcpy(buf.buf,(u8*)&mouse_inf,sizeof(t_mouse_inf));
		
		if(spp_push_data((USB_PC_DEVICE *)&buf,(DEVICE_PC_FIFO_DATA_S *)&to_pc_dat))
		{
			memcpy((u8*)&last_mouse_inf,(u8*)&mouse_inf,sizeof(t_mouse_inf));
		}
	}
}
void main_loop (void)
{

	usb_handle_irq();//must first 
#if 1
	check_mouse_inf_change();
	usb_host_cmd_proc((u8 *)&ack_empty);
	if(emi_flg)
	{
		return;
	}
	
	if (p_post)
    {
        (*p_post)(raw_pkt);
        p_post = NULL;
    }
	proc_suspend();

	notify_usb();
	check_kb_led_status();
    check_pair_timeout();
	
	test_rf_rx_led_show();

	spp_pull_from_pc();
	spp_pull_to_pc();
	//rf_channel_poll();
#endif
	//test_usb_chaba();
	//test_mouse_kb_hid_push();
	//sleep_us(100000);
#if 0
	if(	rf_state_aaa)
	{
		rf_state_aaa=0;
		 //rx_cnt_aaa++;
		//printf("%1x|\n",rx_cnt_aaa);

		 	#if 1	
	     printf("rx=");
         u8 len=(raw_pkt[4]&0x3f)+5;
		 u8 pipe=(raw_pkt[raw_pkt[0]+1]&0x70)>>4;
		 for(u8 i=0;i<len;i++)
		 {
		 	printf("%1x ",raw_pkt[i]);
		 }
		 printf("\n");
		 printf("pipe=%d,rssi=%d",pipe,GET_RX_RSSI(raw_pkt));
		 printf("\n");

	#if 0
			printf("tx=");
			 for(u8 i=0;i<(rf_tx_packet[0]+4);i++)
			 {
			 	printf("%1x ",rf_tx_packet[i]);
			 }
		 	printf("\n");
#endif
		 
	#endif
		
	}
#endif	    
	
}
//............. mouse_hub.........................

DEVICE_PC_FIFO_DATA_S  from_pc_dat;
DEVICE_PC_FIFO_DATA_S  to_pc_dat;
u8 pc_btn[16];

u8 spp_push_data(USB_PC_DEVICE *src,DEVICE_PC_FIFO_DATA_S *des )
{
	USB_PC_DEVICE *p=(USB_PC_DEVICE*)des->fifo[des->wptr&(FROM_PC_FIFO_NUM-1)];
	memcpy(&p->len,&src->len,(src->len+1));
	des->wptr++;
	int fifo_use=(des->wptr-des->rptr)&(FROM_PC_FIFO_NUM*2-1);
	if(fifo_use>FROM_PC_FIFO_NUM)
	{
		des->rptr++;//overlap older data
	}
	return 1;
}

u8 spp_pull_from_pc()
{
	if(from_pc_dat.wptr!=from_pc_dat.rptr)
	{
		USB_PC_DEVICE buf;
		USB_PC_DEVICE *ack;
		USB_PC_DEVICE *p=(USB_PC_DEVICE*)from_pc_dat.fifo[from_pc_dat.rptr&(FROM_PC_FIFO_NUM-1)];
		buf.type=p->type;
		u8 read_flag=0;
		if(p->len==1)//read
		{
			read_flag=1;
			ack=(USB_PC_DEVICE *)&buf;
		}
		else
		{
			ack=p;
		}
		
		if(p->type==MOUSE_INF_CMD)
		{
            if(read_flag)
            {
				buf.len=4;
				buf.buf[0]=mouse_inf.sensor_inf;
				buf.buf[1]=mouse_inf.report_rate;
				buf.buf[2]=mouse_inf.bat;
            }
			
		}
		else if(p->type==BTN_CFG_CMD)
		{
			if(read_flag)//read
			{
				buf.len=17;
				memcpy(buf.buf,pc_btn,16);
			}
			else// write
			{
				for(u8 i=0;i<16;i++)
				{
					pc_btn[i]=p->buf[i];
				}
			}			
		}	
		else if (p->type==DEBUG_REPORT_RATE_CMD)
		{			
			debug_report_rate=p->buf[0];			
		}
		else
		{
			from_pc_dat.rptr++;
			return 1;
		}
	
		if(spp_push_data(ack,(DEVICE_PC_FIFO_DATA_S *)&to_pc_dat))
		{
			from_pc_dat.rptr++;
		}	
	}
	return 1;
}


u8 spp_pull_to_pc()
{
	if(to_pc_dat.wptr!=to_pc_dat.rptr)
	{
		u8 *p=(u8*)to_pc_dat.fifo[to_pc_dat.rptr&(FROM_PC_FIFO_NUM-1)];
		
		if(usb_spp_to_pc(p))
		{
			to_pc_dat.rptr++;
		}
	}
	return 1;
}


u8  special_btn_process(u8 btn)
{
#if 1
	return btn;
#else
	static u8 last_btn=0xff;
	kb_data_t pc_kb_buf={0,0,{0,0,0,0,0,0}};
	u8 special_btn=0;
    u8 ret=btn;
     u8 temp;
    for(u8 i=0;i<8;i++)
    {
		if(pc_btn[i])

		{
			ret&=0xff-BIT(i);
		}
    }
	
   special_btn=btn-ret;
#if 1	
   
	if(last_btn!=special_btn)
	{
		for(u8 i=0;i<8;i++)
		{
			if(special_btn&BIT(i))
			{   
				temp=pc_btn[i];
				if(temp)
				{
					if(temp==0xC8)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LCtrl-0xe0));
						pc_kb_buf.keycode[0]=KB_C;
					}
					else if(temp==0xC9)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LCtrl-0xe0));
						pc_kb_buf.keycode[0]=KB_V;
					}
					else if(temp==0xCA)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LCtrl-0xe0));
						pc_kb_buf.keycode[0]=KB_X;
					}
					else if(temp==0xCB)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LCtrl-0xe0));
						pc_kb_buf.keycode[0]=KB_Y;
					}
					else if(temp==0xCC)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LCtrl-0xe0));
						pc_kb_buf.keycode[0]=KB_Z;
					}
					else if(temp==0xCD)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LCtrl-0xe0));
						pc_kb_buf.keycode[0]=KB_A;
					}
					else if(temp==0xCE)//
					{
						pc_kb_buf.cnt=1;
						pc_kb_buf.ctrl_key=(1<<(KB_LWin-0xe0));
						pc_kb_buf.keycode[0]=KB_L;
					}
					else
					{
						
						pc_kb_buf.keycode[0]=temp;
						pc_kb_buf.cnt=1;
					}
					
				}
				break;
			}
		}
		
		
		kb_data_handle(&pc_kb_buf.cnt);
		last_btn=special_btn;
	}
#endif	
	return ret;
#endif

}


