/********************************************************************************************************
 * @file     main.c
 *
 * @brief    This is the source file for TLSR8278
 *
 * @author	 Driver Group
 * @date     May 8, 2018
 *
 * @par      Copyright (c) 2018, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *           The information contained herein is confidential property of Telink
 *           Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *           of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *           Co., Ltd. and the licensee or the terms described here-in. This heading
 *           MUST NOT be removed from this file.
 *
 *           Licensees are granted free, non-transferable use of the information in this
 *           file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 * @par      History:
 * 			 1.initial release(DEC. 26 2018)
 *
 * @version  A001
 *
 *******************************************************************************************************/
#include "AAA_project_config.h"

#define RF_MODE  RF_MODE_BLE_2M
u8 rf_chn;
u8 pwr;
u8	 chn_idx = 0;
u8	 test_mode_sel = 0;

typedef enum 
{
	CARRIER_MODE=0,
	CARRIER_DATA_MODE=1,
	RX_MODE=2,
	TX_MODE=3,
}EMI_MODE;

#define DATA_TYPE 0 //0:pbrs9 	1:0xf0	 2:0x55

u8 emi_flg = 0;


void emi_init()
{
	//unsigned char chnidx=0;
	write_reg32(0x408,0x29417671 );//access code  0xf8118ac9
	write_reg8(0x13c,0x10); // print buffer size set

	//write_reg8(0x40005,tx_cnt);//tx_cnt
	//write_reg8(0x40006,run);//run
	//write_reg8(0x40007,cmd_now);//cmd
	//write_reg8(0x40008,power_level);//power
	//write_reg8(0x40009,chn);//chn
	//write_reg8(0x4000a,mode);//mode
	//write_reg8(0x4000b,hop);//hop
	//write_reg8(0x40004,0);
	//write_reg32(0x4000c,0);
	//gpio_shutdown(GPIO_ALL);//for pm
	analog_write(0x33,0xff);

	//flash_read_page(0x77000,1,&chnidx);
	//if(chnidx!=0xff)
	{
		//chnidx&=0x3f;
		//analog_write(0x8a,(analog_read(0x8a)&0xc0)|chnidx);//close internal cap
	}
}

void usb_host_cmd_proc(u8 *pkt)
{
    extern u8		host_cmd[8];
   // extern u8		host_cmd_paring_ok;
    u8 tbl_chn[4] = {05, 30, 70,80};

  
   u8		dongle_host_cmd1;

    if ((host_cmd[0] == 0x5) && (host_cmd[2] == 0x3))
    {
        host_cmd[0] = 0;
        dongle_host_cmd1 = host_cmd[1];

        if (dongle_host_cmd1 > 12 && dongle_host_cmd1 < 16)   //soft paring
        {
			#if 0
            host_cmd_paring_ok = 0;
            rf_paring_tick = clock_time();  //update paring time

            if (dongle_host_cmd1 == 13)     //kb and mouse tolgether
            {
                mouse_paring_enable = 1;
                keyboard_paring_enable = 1;
            }
            else if (dongle_host_cmd1 == 14) //mouse only
            {
                mouse_paring_enable = 1;
            }
            else if (dongle_host_cmd1 == 15)  //keyboard only
            {
                keyboard_paring_enable = 1;
            }
			#else
			    //set_pair_flag();
			#endif
        }
        else if (dongle_host_cmd1 > 0 && dongle_host_cmd1 < 13) //1-12:EMI
        {
           // if(emi_flg==0)
            {
				irq_disable();
            	reg_tmr_ctrl &= ~FLD_TMR1_EN;
				
				emi_init();
            }
            
            rf_set_tx_rx_off();
			emi_flg = 1;

            chn_idx = (dongle_host_cmd1 - 1) / 4;
            test_mode_sel = (dongle_host_cmd1 - 1) % 4;
			rf_chn=tbl_chn[chn_idx];
			pwr=user_config.tx_power_emi;
			#if 1
            if(test_mode_sel==CARRIER_MODE)
            {
				rf_emi_single_tone(pwr,rf_chn);
            }
			else if(test_mode_sel==CARRIER_DATA_MODE)//cd
			{
				rf_emi_tx_continue_setup(RF_MODE,pwr,rf_chn,DATA_TYPE);
			}
			else if(test_mode_sel==RX_MODE)//rx
			{
				rf_emi_rx(RF_MODE,rf_chn);
			}
			else if(test_mode_sel==TX_MODE)//rx
			{
				rf_emi_tx_burst_setup(RF_MODE,pwr,rf_chn,DATA_TYPE);
			}
			#else
			emi_process(RF_MODE_PRIVATE_2M,pwr,chn_idx,test_mode_sel);
			#endif
			
    	}
			
     } 
	if(emi_flg)
	{
		 if(test_mode_sel==CARRIER_DATA_MODE)//cd
		{
			while(!host_cmd[0])
			{
				rf_continue_mode_run();
					while(read_reg8(0x41c) & 0x1)
					{
						usb_handle_irq();
						if(host_cmd[0])
						{
                           write_reg32(0x41c, 0);
							break;
						}
					}
			}
		}
		else if(test_mode_sel==RX_MODE)//rx
		{
			rf_emi_rx_loop();
		}
		else if(test_mode_sel==TX_MODE)//rx
		{
			rf_emi_tx_burst_loop(RF_MODE,DATA_TYPE);
		}
	}
}

